/*
 *  ColorCube.c
 *  DrawExamples
 *
 *  Created by Simone Portuesi on 08/03/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */

/* Università Roma 3, DIA, Informatica Grafica Esercitazione del 8/3/2006 */

/* Modello esempio 3: Cubo Colore                                         */

/* Include GL, GLU & GLUT */
#ifdef WIN32
#include <windows.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>
#endif

#ifdef __APPLE__
#include <OpenGL/gl.h>
#include <OpenGL/glu.h>
#include <GLUT/glut.h>
#endif

#ifdef linux
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>
#endif

/* Include some standard stuff */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

/* Include my files */
#include "main.h"

int use_varray=0;

void display_model() {
	GLfloat cpoints[8][3] = { { 0.0, 0.0, 0.0 },
	                         { 1.0, 0.0, 0.0 },
							 { 0.0, 1.0, 0.0 },
							 { 1.0, 1.0, 0.0 },
							 { 0.0, 0.0, 1.0 },
							 { 1.0, 0.0, 1.0 },
							 { 0.0, 1.0, 1.0 },
							 { 1.0, 1.0, 1.0 }};
	GLubyte indices[6][4] = { { 0, 2, 3, 1 }, //back
							  { 7, 6, 4, 5 }, //front
							  { 0, 4, 6, 2 }, //left
							  { 1, 5, 7, 3 }, //right
							  { 0, 1, 5, 4 }, //bottom
							  { 7, 3, 2, 6 } };
							  
	int i,j;
	glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
	
	/* For each face and point */
	if (!use_varray) {
		glBegin(GL_QUADS);
		for(i=0;i<6;i++) {
			for(j=0;j<4;j++) {
				glColor3fv(cpoints[indices[i][j]]);
				glVertex3fv(cpoints[indices[i][j]]);
			}
		}
		glEnd();
	} else {
		/* Oppure */
		glEnableClientState(GL_VERTEX_ARRAY);
		glEnableClientState(GL_COLOR_ARRAY);
		glVertexPointer( 3, GL_FLOAT, 0, cpoints);
		glColorPointer( 3, GL_FLOAT, 0, cpoints);
		glDrawElements(GL_QUADS, 24, GL_UNSIGNED_BYTE, indices );
		glDisableClientState( GL_VERTEX_ARRAY );
		glDisableClientState( GL_COLOR_ARRAY );
	}
}

/* Model specific keys */
void keyboard_model(unsigned char key, int x, int y) {
	switch(key) {
		case 'v':
		case 'V':
			use_varray=!use_varray;
			glutPostRedisplay();
			break;
	}
}
	
