/*
 *  PrimitiveCircle.c
 *  DrawExamples
 *
 *  Created by Simone Portuesi on 08/03/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */

/* Università Roma 3, DIA, Informatica Grafica Esercitazione del 8/3/2006 */

/* Modello esempio 1: Primitive e cerchio punti                           */

/* Include GL, GLU & GLUT */
#ifdef WIN32
#include <windows.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>
#endif

#ifdef __APPLE__
#include <OpenGL/gl.h>
#include <OpenGL/glu.h>
#include <GLUT/glut.h>
#endif

#ifdef linux
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>
#endif

/* Include some standard stuff */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

/* Include my files */
#include "main.h"


/* Helper function */
void mkpoints() {
	int i;
	
	for (i=0;i < 12; i ++) {
		glVertex2f(cos(M_PI/6*i),
		          sin(M_PI/6*i));
	}
}

GLenum primtype=GL_POINTS;

/* Current model */
void display_model() {
		int i;
	GLubyte polystipple[32][8];
	
	/* Set drawing mode */
	for(i=0;i<32;i++) memset(polystipple[i] , (GLubyte) i%2?0xAA:0x55 ,  8 );
	glPolygonMode(GL_FRONT,GL_FILL);
	glEnable(GL_POLYGON_STIPPLE);
	glPolygonStipple(polystipple);
	glColor3f(0.8,0.8,0.8);
	glPointSize(6);
	glLineWidth(2.0);
	
	/* First draw as is */
	glBegin(primtype);
	mkpoints();
	glEnd();
	
	/* Change Drawing mode */
	glDisable(GL_POLYGON_STIPPLE);
	glEnable(GL_LINE_STIPPLE);
	glLineStipple(1,0xB6B6);
	glDisable(GL_DEPTH_TEST);
	
	/* Drawn lines, draw points too */
	if(primtype>=GL_LINES && primtype < GL_TRIANGLES) {
		glBegin(GL_POINTS);
		mkpoints();
		glEnd();
	} 
	
	/* Drawn poligons, draw points & lines */
	if(primtype>=GL_TRIANGLES) {
		glPolygonMode(GL_FRONT_AND_BACK,GL_POINT);
		glColor3f(1.0,1.0,1.0);
		glBegin(primtype);
		mkpoints();
		glEnd();
		glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);
		glColor3f(1.0,1.0,1.0);
		glBegin(primtype);
		mkpoints();
		glEnd();
	}
	
	/* Disable stipple */
	glDisable(GL_LINE_STIPPLE);
	glEnable(GL_DEPTH_TEST);
}

/* Model specific keys */
void keyboard_model(unsigned char key, int x, int y) {

	switch(key) {
		case 'p':
		case 'P':
			primtype=(primtype + 1) % (GL_POLYGON + 1);
			glutPostRedisplay();
			break;
	}

}


