/*
 *  ProfileRotate.c
 *  DrawExamples
 *
 *  Created by Simone Portuesi on 08/03/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */

/* Università Roma 3, DIA, Informatica Grafica Esercitazione del 8/3/2006 */

/* Modello esempio 2: Rotazione profile                                   */

/* Include GL, GLU & GLUT */
#ifdef WIN32
#include <windows.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>
#endif

#ifdef __APPLE__
#include <OpenGL/gl.h>
#include <OpenGL/glu.h>
#include <GLUT/glut.h>
#endif

#ifdef linux
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>
#endif

/* Include some standard stuff */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

/* Include my files */
#include "main.h"

int shownormals=0;

void rotateprofile(GLfloat profile[][2], int n_profile, int n) {
	int i,j,k;
	GLfloat angle0,angle1;
	GLfloat step=2.0 * M_PI / n;
	GLfloat profileN[2];
	GLfloat d;
		
	/* For each segment */
	for(i=0;i<n_profile-1;i++) {
		/* For each slice */
		for(j=0;j<n;j++) {
			/* Calculate angles */
			angle0=j * step;
			angle1=((j+1) % n) * step;
			
			/* Calculate normal of profile */
			profileN[0] = profile[i][1] -  profile[i+1][1];
			profileN[1] = profile[i+1][0] -  profile[i][0];
			d=sqrt(profileN[0] * profileN[0] + profileN[1] * profileN[1]);
			profileN[0] /=d;
			profileN[1] /=d;
			
			if(shownormals) {
				glDisable(GL_LIGHTING);
				glBegin(GL_LINES);
				glVertex3f(profile[i][0] * cos(angle0),
						profile[i][1] ,
						profile[i][0] * sin(angle0));
				glVertex3f((profile[i][0] + profileN[0])  * cos(angle0),
						profile[i][1] + profileN[1],
						(profile[i][0] + profileN[0])  * sin(angle0) );
			
				glEnd();
				glBegin(GL_LINES);
				glVertex3f(profile[i+1][0] * cos(angle1),
						profile[i+1][1] ,
						profile[i+1][0] * sin(angle1));
				glVertex3f((profile[i+1][0] + profileN[0])  * cos(angle1),
						profile[i+1][1] + profileN[1],
						(profile[i+1][0] + profileN[0])  * sin(angle1) );
			
				glEnd();
				glEnable(GL_LIGHTING);
			}
			
			/* Draw face, updating the angle */
			glBegin(GL_POLYGON);
			glPolygonMode(GL_FRONT,GL_FILL);
			
			/* first point of profile projected on first angle */
			glNormal3f(profileN[0] * cos(angle0),
					   profileN[1],
					   profileN[0] * sin(angle0));
			glVertex3f( profile[i][0] * cos(angle0),
			            profile[i][1],
						profile[i][0] * sin(angle0) );
						
			/* second point of profile projected on first angle */
			glNormal3f(profileN[0] * cos(angle0),
					   profileN[1],
					   profileN[0] * sin(angle0));
			glVertex3f( profile[i+1][0] * cos(angle0),
			            profile[i+1][1],
						profile[i+1][0] * sin(angle0) );
									
			/* second point of profile projected on second angle */						
			glNormal3f(profileN[0] * cos(angle1),
					   profileN[1],
					   profileN[0] * sin(angle1));
			glVertex3f( profile[i+1][0] * cos(angle1),
			            profile[i+1][1],
						profile[i+1][0] * sin(angle1));
			
			/* first point of profile projected on second angle */
			glNormal3f(profileN[0] *  cos(angle1),
					   profileN[1],
					   profileN[0]*  sin(angle1));
			glVertex3f( profile[i][0] * cos(angle1),
			            profile[i][1],
						profile[i][0] * sin(angle1));
			
			glEnd();

		}
	}
} 


/* Current model */
void display_model() {
	GLfloat light_pos[]={ 3.0, 3.0, 3.0 };
	GLfloat profile[][2] = { {0.1, 1    }, 
							 {0.8, 0.5  }, 
							 {1  , 0    },
							 {0.8, -0.5 }, 
							 {1,   -1   },
							 {0.8, -1   },
							 {0,  0     } };
	int n_profile=7;
		
	/* Fiat Lux */	
	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
	glEnable(GL_NORMALIZE);
	//glShadeModel(GL_FLAT);
	glLightfv(GL_LIGHT0, GL_POSITION, light_pos );
	
	/* Make profile */
	glColor3f(0.8,0.8,0.8);
	rotateprofile(profile,n_profile,8);
	
	/* Turn off lighting */
	glDisable(GL_NORMALIZE);
	glDisable(GL_LIGHTING);
}


/* Model specific keys */
void keyboard_model(unsigned char key, int x, int y) {
	switch(key) {
		case 'n':
		case 'N':
			shownormals=!shownormals;
			glutPostRedisplay();
			break;
	}
}

